=== debian/changelog ===
ros-noetic-prosilica-gige-sdk (1.26.3-2buster) buster; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Austin Hendrix <namniart@gmail.com>  Sat, 06 Mar 2021 07:50:18 -0000
